<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/log-0.4.17/src/macros.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>macros.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/favicon.ico"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../log/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../log/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../log/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
</pre><pre class="rust"><code><span class="comment">// Copyright 2014-2015 The Rust Project Developers. See the COPYRIGHT</span>
<span class="comment">// file at the top-level directory of this distribution and at</span>
<span class="comment">// http://rust-lang.org/COPYRIGHT.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// http://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or http://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">/// The standard logging macro.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This macro will generically log with the specified `Level` and `format!`</span>
<span class="doccomment">/// based argument list.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```edition2018</span>
<span class="doccomment">/// use log::{log, Level};</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn main() {</span>
<span class="doccomment">/// let data = (42, &quot;Forty-two&quot;);</span>
<span class="doccomment">/// let private_data = &quot;private&quot;;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// log!(Level::Error, &quot;Received errors: {}, {}&quot;, data.0, data.1);</span>
<span class="doccomment">/// log!(target: &quot;app_events&quot;, Level::Warn, &quot;App warning: {}, {}, {}&quot;,</span>
<span class="doccomment">///     data.0, data.1, private_data);</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">log</span> {
    <span class="comment">// log!(target: &quot;my_target&quot;, Level::Info; key1 = 42, key2 = true; &quot;a {} event&quot;, &quot;log&quot;);</span>
    (<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>:<span class="ident">expr</span>),<span class="op">+</span>; $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; ({
        <span class="kw">let</span> <span class="ident">lvl</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>;
        <span class="kw">if</span> <span class="ident">lvl</span> <span class="op">&lt;</span><span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::STATIC_MAX_LEVEL</span> <span class="op">&amp;&amp;</span> <span class="ident">lvl</span> <span class="op">&lt;</span><span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::max_level</span>() {
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::__private_api_log</span>(
                <span class="macro">__log_format_args!</span>($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>),
                <span class="ident">lvl</span>,
                <span class="kw-2">&amp;</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>, <span class="macro">__log_module_path!</span>(), <span class="macro">__log_file!</span>(), <span class="macro">__log_line!</span>()),
                <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::__private_api::Option::Some</span>(<span class="kw-2">&amp;</span>[$((<span class="macro">__log_key!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>), <span class="kw-2">&amp;</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>)),<span class="op">+</span>])
            );
        }
    });

    <span class="comment">// log!(target: &quot;my_target&quot;, Level::Info; &quot;a {} event&quot;, &quot;log&quot;);</span>
    (<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; ({
        <span class="kw">let</span> <span class="ident">lvl</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>;
        <span class="kw">if</span> <span class="ident">lvl</span> <span class="op">&lt;</span><span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::STATIC_MAX_LEVEL</span> <span class="op">&amp;&amp;</span> <span class="ident">lvl</span> <span class="op">&lt;</span><span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::max_level</span>() {
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::__private_api_log</span>(
                <span class="macro">__log_format_args!</span>($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>),
                <span class="ident">lvl</span>,
                <span class="kw-2">&amp;</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>, <span class="macro">__log_module_path!</span>(), <span class="macro">__log_file!</span>(), <span class="macro">__log_line!</span>()),
                <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::__private_api::Option::None</span>,
            );
        }
    });

    <span class="comment">// log!(Level::Info, &quot;a log event&quot;)</span>
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="ident">target</span>: <span class="macro">__log_module_path!</span>(), <span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>));
}

<span class="doccomment">/// Logs a message at the error level.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```edition2018</span>
<span class="doccomment">/// use log::error;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn main() {</span>
<span class="doccomment">/// let (err_info, port) = (&quot;No connection&quot;, 22);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// error!(&quot;Error: {} on port {}&quot;, err_info, port);</span>
<span class="doccomment">/// error!(target: &quot;app_events&quot;, &quot;App Error: {}, Port: {}&quot;, err_info, 22);</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">error</span> {
    <span class="comment">// error!(target: &quot;my_target&quot;, key1 = 42, key2 = true; &quot;a {} event&quot;, &quot;log&quot;)</span>
    <span class="comment">// error!(target: &quot;my_target&quot;, &quot;a {} event&quot;, &quot;log&quot;)</span>
    (<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Error</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>));

    <span class="comment">// error!(&quot;a {} event&quot;, &quot;log&quot;)</span>
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Error</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>))
}

<span class="doccomment">/// Logs a message at the warn level.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```edition2018</span>
<span class="doccomment">/// use log::warn;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn main() {</span>
<span class="doccomment">/// let warn_description = &quot;Invalid Input&quot;;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// warn!(&quot;Warning! {}!&quot;, warn_description);</span>
<span class="doccomment">/// warn!(target: &quot;input_events&quot;, &quot;App received warning: {}&quot;, warn_description);</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">warn</span> {
    <span class="comment">// warn!(target: &quot;my_target&quot;, key1 = 42, key2 = true; &quot;a {} event&quot;, &quot;log&quot;)</span>
    <span class="comment">// warn!(target: &quot;my_target&quot;, &quot;a {} event&quot;, &quot;log&quot;)</span>
    (<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Warn</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>));

    <span class="comment">// warn!(&quot;a {} event&quot;, &quot;log&quot;)</span>
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Warn</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>))
}

<span class="doccomment">/// Logs a message at the info level.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```edition2018</span>
<span class="doccomment">/// use log::info;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn main() {</span>
<span class="doccomment">/// # struct Connection { port: u32, speed: f32 }</span>
<span class="doccomment">/// let conn_info = Connection { port: 40, speed: 3.20 };</span>
<span class="doccomment">///</span>
<span class="doccomment">/// info!(&quot;Connected to port {} at {} Mb/s&quot;, conn_info.port, conn_info.speed);</span>
<span class="doccomment">/// info!(target: &quot;connection_events&quot;, &quot;Successfull connection, port: {}, speed: {}&quot;,</span>
<span class="doccomment">///       conn_info.port, conn_info.speed);</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">info</span> {
    <span class="comment">// info!(target: &quot;my_target&quot;, key1 = 42, key2 = true; &quot;a {} event&quot;, &quot;log&quot;)</span>
    <span class="comment">// info!(target: &quot;my_target&quot;, &quot;a {} event&quot;, &quot;log&quot;)</span>
    (<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Info</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>));

    <span class="comment">// info!(&quot;a {} event&quot;, &quot;log&quot;)</span>
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Info</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>))
}

<span class="doccomment">/// Logs a message at the debug level.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```edition2018</span>
<span class="doccomment">/// use log::debug;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn main() {</span>
<span class="doccomment">/// # struct Position { x: f32, y: f32 }</span>
<span class="doccomment">/// let pos = Position { x: 3.234, y: -1.223 };</span>
<span class="doccomment">///</span>
<span class="doccomment">/// debug!(&quot;New position: x: {}, y: {}&quot;, pos.x, pos.y);</span>
<span class="doccomment">/// debug!(target: &quot;app_events&quot;, &quot;New position: x: {}, y: {}&quot;, pos.x, pos.y);</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">debug</span> {
    <span class="comment">// debug!(target: &quot;my_target&quot;, key1 = 42, key2 = true; &quot;a {} event&quot;, &quot;log&quot;)</span>
    <span class="comment">// debug!(target: &quot;my_target&quot;, &quot;a {} event&quot;, &quot;log&quot;)</span>
    (<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Debug</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>));

    <span class="comment">// debug!(&quot;a {} event&quot;, &quot;log&quot;)</span>
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Debug</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>))
}

<span class="doccomment">/// Logs a message at the trace level.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```edition2018</span>
<span class="doccomment">/// use log::trace;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn main() {</span>
<span class="doccomment">/// # struct Position { x: f32, y: f32 }</span>
<span class="doccomment">/// let pos = Position { x: 3.234, y: -1.223 };</span>
<span class="doccomment">///</span>
<span class="doccomment">/// trace!(&quot;Position is: x: {}, y: {}&quot;, pos.x, pos.y);</span>
<span class="doccomment">/// trace!(target: &quot;app_events&quot;, &quot;x is {} and y is {}&quot;,</span>
<span class="doccomment">///        if pos.x &gt;= 0.0 { &quot;positive&quot; } else { &quot;negative&quot; },</span>
<span class="doccomment">///        if pos.y &gt;= 0.0 { &quot;positive&quot; } else { &quot;negative&quot; });</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">trace</span> {
    <span class="comment">// trace!(target: &quot;my_target&quot;, key1 = 42, key2 = true; &quot;a {} event&quot;, &quot;log&quot;)</span>
    <span class="comment">// trace!(target: &quot;my_target&quot;, &quot;a {} event&quot;, &quot;log&quot;)</span>
    (<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Trace</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>));

    <span class="comment">// trace!(&quot;a {} event&quot;, &quot;log&quot;)</span>
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="op">+</span>) =&gt; (<span class="macro">log!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Level::Trace</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="op">+</span>))
}

<span class="doccomment">/// Determines if a message logged at the specified level in that module will</span>
<span class="doccomment">/// be logged.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This can be used to avoid expensive computation of log message arguments if</span>
<span class="doccomment">/// the message would be ignored anyway.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```edition2018</span>
<span class="doccomment">/// use log::Level::Debug;</span>
<span class="doccomment">/// use log::{debug, log_enabled};</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn foo() {</span>
<span class="doccomment">/// if log_enabled!(Debug) {</span>
<span class="doccomment">///     let data = expensive_call();</span>
<span class="doccomment">///     debug!(&quot;expensive debug data: {} {}&quot;, data.x, data.y);</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// if log_enabled!(target: &quot;Global&quot;, Debug) {</span>
<span class="doccomment">///    let data = expensive_call();</span>
<span class="doccomment">///    debug!(target: &quot;Global&quot;, &quot;expensive debug data: {} {}&quot;, data.x, data.y);</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// # struct Data { x: u32, y: u32 }</span>
<span class="doccomment">/// # fn expensive_call() -&gt; Data { Data { x: 0, y: 0 } }</span>
<span class="doccomment">/// # fn main() {}</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">log_enabled</span> {
    (<span class="ident">target</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>:<span class="ident">expr</span>) =&gt; {{
        <span class="kw">let</span> <span class="ident">lvl</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>;
        <span class="ident">lvl</span> <span class="op">&lt;</span><span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::STATIC_MAX_LEVEL</span>
            <span class="op">&amp;&amp;</span> <span class="ident">lvl</span> <span class="op">&lt;</span><span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::max_level</span>()
            <span class="op">&amp;&amp;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::__private_api_enabled</span>(<span class="ident">lvl</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">target</span>)
    }};
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>:<span class="ident">expr</span>) =&gt; {
        <span class="macro">log_enabled!</span>(<span class="ident">target</span>: <span class="macro">__log_module_path!</span>(), <span class="macro-nonterminal">$</span><span class="macro-nonterminal">lvl</span>)
    };
}

<span class="comment">// The log macro above cannot invoke format_args directly because it uses</span>
<span class="comment">// local_inner_macros. A format_args invocation there would resolve to</span>
<span class="comment">// $crate::format_args which does not exist. Instead invoke format_args here</span>
<span class="comment">// outside of local_inner_macros so that it resolves (probably) to</span>
<span class="comment">// core::format_args or std::format_args. Same for the several macros that</span>
<span class="comment">// follow.</span>
<span class="comment">//</span>
<span class="comment">// This is a workaround until we drop support for pre-1.30 compilers. At that</span>
<span class="comment">// point we can remove use of local_inner_macros, use $crate:: when invoking</span>
<span class="comment">// local macros, and invoke format_args directly.</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">__log_format_args</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">args</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; {
        <span class="macro">format_args!</span>($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">args</span>)<span class="kw-2">*</span>)
    };
}

<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">__log_module_path</span> {
    () =&gt; {
        <span class="macro">module_path!</span>()
    };
}

<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">__log_file</span> {
    () =&gt; {
        <span class="macro">file!</span>()
    };
}

<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">__log_line</span> {
    () =&gt; {
        <span class="macro">line!</span>()
    };
}

<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">__log_key</span> {
    <span class="comment">// key1 = 42</span>
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">args</span>:<span class="ident">ident</span>)<span class="kw-2">*</span>) =&gt; {
        <span class="macro">stringify!</span>($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">args</span>)<span class="kw-2">*</span>)
    };
    <span class="comment">// &quot;key1&quot; = 42</span>
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">args</span>:<span class="ident">expr</span>)<span class="kw-2">*</span>) =&gt; {
        $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">args</span>)<span class="op">*</span>
    };
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="log" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>